Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3876)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 3883)
@@ -1002,42 +1073,40 @@
 !
 !--       Send coarse grid information to child
-          CALL pmc_send_to_child( child_id, parent_grid_info_real,             &
-                                   SIZE( parent_grid_info_real ), 0, 21,       &
-                                   ierr )
-          CALL pmc_send_to_child( child_id, parent_grid_info_int,  3, 0,       &
-                                   22, ierr )
+          CALL pmc_send_to_child( child_id, parent_grid_info_real,                                  &
+                                  SIZE( parent_grid_info_real ), 0, 21,                             &
+                                  ierr )
+          CALL pmc_send_to_child( child_id, parent_grid_info_int,  3, 0,                            &
+                                  22, ierr )
 !
 !--       Send local grid to child
-          CALL pmc_send_to_child( child_id, coord_x, nx+1+2*nbgp, 0, 24,       &
-                                   ierr )
-          CALL pmc_send_to_child( child_id, coord_y, ny+1+2*nbgp, 0, 25,       &
-                                   ierr )
+          CALL pmc_send_to_child( child_id, coord_x, nx+1+2*nbgp, 0, 24,                            &
+                                  ierr )
+          CALL pmc_send_to_child( child_id, coord_y, ny+1+2*nbgp, 0, 25,                            &
+                                  ierr )
 !
 !--       Also send the dzu-, dzw-, zu- and zw-arrays here
-          CALL pmc_send_to_child( child_id, dzu, nz_cl+1, 0, 26, ierr )
-          CALL pmc_send_to_child( child_id, dzw, nz_cl+1, 0, 27, ierr )
-          CALL pmc_send_to_child( child_id, zu,  nz_cl+2, 0, 28, ierr )
-          CALL pmc_send_to_child( child_id, zw,  nz_cl+2, 0, 29, ierr )
-
-       ENDIF
-
-       CALL MPI_BCAST( nomatch, 1, MPI_INTEGER, 0, comm2d, ierr )
-       IF ( nomatch /= 0 )  THEN
-          WRITE ( message_string, * )  'nested child domain does ',            &
-                                       'not fit into its parent domain'
-          CALL message( 'pmci_setup_parent', 'PA0425', 3, 2, 0, 6, 0 )
-       ENDIF
+          CALL pmc_send_to_child( child_id, dzu, nz_child + 1, 0, 26, ierr )
+          CALL pmc_send_to_child( child_id, dzw, nz_child + 1, 0, 27, ierr )
+          CALL pmc_send_to_child( child_id, zu,  nz_child + 2, 0, 28, ierr )
+          CALL pmc_send_to_child( child_id, zw,  nz_child + 2, 0, 29, ierr )
+
+          IF ( nomatch /= 0 )  THEN
+             WRITE ( message_string, * ) 'nested child domain does not fit into its parent domain'
+             CALL message( 'pmci_setup_parent', 'PA0425', 3, 2, 0, 6, 0 )
+          ENDIF
   
-       CALL MPI_BCAST( nest_overlap, 1, MPI_INTEGER, 0, comm2d, ierr )
-       IF ( nest_overlap /= 0  .AND.  nesting_mode /= 'vertical' )  THEN
-          WRITE ( message_string, * )  'nested parallel child domains overlap'
-          CALL message( 'pmci_setup_parent', 'PA0426', 3, 2, 0, 6, 0 )
-       ENDIF
-      
-       CALL MPI_BCAST( nz_cl, 1, MPI_INTEGER, 0, comm2d, ierr )
+          IF ( nest_overlap /= 0  .AND.  nesting_mode /= 'vertical' )  THEN
+             WRITE ( message_string, * ) 'nested parallel child domains overlap'
+             CALL message( 'pmci_setup_parent', 'PA0426', 3, 2, 0, 6, 0 )
+          ENDIF
+          
+       ENDIF  ! ( myid == 0 ) 
+
+       CALL MPI_BCAST( nz_child, 1, MPI_INTEGER, 0, comm2d, ierr )
 
        CALL MPI_BCAST( childgrid(m), STORAGE_SIZE(childgrid(1))/8, MPI_BYTE, 0, comm2d, ierr )
 !
 !--    TO_DO: Klaus: please give a comment what is done here
+!  DO IT YOURSELF       
        CALL pmci_create_index_list
 !
@@ -1047,39 +1116,40 @@
 !--    have to be specified again
        CALL pmc_s_clear_next_array_list
-       DO  WHILE ( pmc_s_getnextarray( child_id, myname ) )
+       DO WHILE ( pmc_s_getnextarray( child_id, myname ) )
           IF ( INDEX( TRIM( myname ), 'chem_' ) /= 0 )  THEN             
              CALL pmci_set_array_pointer( myname, child_id = child_id,         &
-                                          nz_cl = nz_cl, n = n )
+                                          nz_child = nz_child, n = n )
              n = n + 1  
           ELSEIF ( INDEX( TRIM( myname ), 'an_' ) /= 0 )  THEN
              CALL pmci_set_array_pointer( myname, child_id = child_id,         &
-                                          nz_cl = nz_cl, n = ib )
-             ib = ib + 1 
+                                          nz_child = nz_child, n = lb )
+             lb = lb + 1 
           ELSEIF ( INDEX( TRIM( myname ), 'am_' ) /= 0 )  THEN
              CALL pmci_set_array_pointer( myname, child_id = child_id,         &
-                                          nz_cl = nz_cl, n = ic )
-             ic = ic + 1 
+                                          nz_child = nz_child, n = lc )
+             lc = lc + 1 
           ELSEIF ( INDEX( TRIM( myname ), 'sg_' ) /= 0  .AND.                  &
              .NOT. salsa_gases_from_chem )                                     &
           THEN
              CALL pmci_set_array_pointer( myname, child_id = child_id,         &
-                                          nz_cl = nz_cl, n = ig )
-             ig = ig + 1
+                                          nz_child = nz_child, n = lg )
+             lg = lg + 1
           ELSE
-             CALL pmci_set_array_pointer( myname, child_id = child_id,         &
-                                          nz_cl = nz_cl )
+             CALL pmci_set_array_pointer( myname, child_id = child_id, nz_child = nz_child )
           ENDIF
        ENDDO
 
        CALL pmc_s_setind_and_allocmem( child_id )
-    ENDDO
-
-    IF ( ( SIZE( pmc_parent_for_child ) - 1 > 0 ) .AND. myid == 0 )  THEN 
-       DEALLOCATE( ch_xl )
-       DEALLOCATE( ch_xr )
-       DEALLOCATE( ch_ys )
-       DEALLOCATE( ch_yn )
+       
+    ENDDO  ! m
+
+    IF ( ( SIZE( pmc_parent_for_child ) - 1 > 0 ) .AND. myid == 0 )  THEN
+       DEALLOCATE( child_x_left )
+       DEALLOCATE( child_x_right )
+       DEALLOCATE( child_y_south )
+       DEALLOCATE( child_y_north )
     ENDIF
 
+    
  CONTAINS
 
@@ -1108,4 +1178,5 @@
        INTEGER(iwp), DIMENSION(:,:), ALLOCATABLE  ::  index_list         !<
 
+       
        IF ( myid == 0 )  THEN
 !          
@@ -1138,8 +1209,8 @@
 !
 !--          Area along y required by actual child PE
-             DO  j = coarse_bound_all(3,k), coarse_bound_all(4,k)  !: j = jcs, jcn of PE# k 
+             DO  j = coarse_bound_all(3,k), coarse_bound_all(4,k)  !: j = jps, jpn of PE# k 
 !
 !--             Area along x required by actual child PE
-                DO  i = coarse_bound_all(1,k), coarse_bound_all(2,k)  !: i = icl, icr of PE# k 
+                DO  i = coarse_bound_all(1,k), coarse_bound_all(2,k)  !: i = ipl, ipr of PE# k 
 
                    px = i / nrx
@@ -1192,23 +1263,24 @@
         IMPLICIT  NONE
 
-        INTEGER(iwp) :: nbgp_lpm = 1
-
-        nbgp_lpm = min(nbgp_lpm, nbgp)
-
-        childgrid(m)%nx = nx_cl
-        childgrid(m)%ny = ny_cl
-        childgrid(m)%nz = nz_cl
-        childgrid(m)%dx = dx_cl
-        childgrid(m)%dy = dy_cl
-        childgrid(m)%dz = dz_cl
-
-        childgrid(m)%lx_coord   = cl_coord_x(0)
-        childgrid(m)%lx_coord_b = cl_coord_x(-nbgp_lpm)
-        childgrid(m)%rx_coord   = cl_coord_x(nx_cl)+dx_cl
-        childgrid(m)%rx_coord_b = cl_coord_x(nx_cl+nbgp_lpm)+dx_cl
-        childgrid(m)%sy_coord   = cl_coord_y(0)
-        childgrid(m)%sy_coord_b = cl_coord_y(-nbgp_lpm)
-        childgrid(m)%ny_coord   = cl_coord_y(ny_cl)+dy_cl
-        childgrid(m)%ny_coord_b = cl_coord_y(ny_cl+nbgp_lpm)+dy_cl
+        INTEGER(iwp) ::  nbgp_lpm = 1  !<
+
+        
+        nbgp_lpm = MIN( nbgp_lpm, nbgp )
+
+        childgrid(m)%nx = nx_child
+        childgrid(m)%ny = ny_child
+        childgrid(m)%nz = nz_child
+        childgrid(m)%dx = dx_child
+        childgrid(m)%dy = dy_child
+        childgrid(m)%dz = dz_child
+
+        childgrid(m)%lx_coord   = child_coord_x(0)
+        childgrid(m)%lx_coord_b = child_coord_x(-nbgp_lpm)
+        childgrid(m)%rx_coord   = child_coord_x(nx_child) + dx_child
+        childgrid(m)%rx_coord_b = child_coord_x(nx_child+nbgp_lpm) + dx_child
+        childgrid(m)%sy_coord   = child_coord_y(0)
+        childgrid(m)%sy_coord_b = child_coord_y(-nbgp_lpm)
+        childgrid(m)%ny_coord   = child_coord_y(ny_child) + dy_child
+        childgrid(m)%ny_coord_b = child_coord_y(ny_child+nbgp_lpm) + dy_child
         childgrid(m)%uz_coord   = zmax_coarse(2)
         childgrid(m)%uz_coord_b = zmax_coarse(1)
@@ -1226,37 +1298,22 @@
     IMPLICIT NONE
 
-
-    CHARACTER(LEN=da_namelen) ::  myname     !<
-    CHARACTER(LEN=5) ::  salsa_char          !<
-    INTEGER(iwp) ::  ib         !< running index for aerosol size bins
-    INTEGER(iwp) ::  ic         !< running index for aerosol mass bins
-    INTEGER(iwp) ::  ierr       !<
-    INTEGER(iwp) ::  icl        !< Left index limit for children's parent-grid arrays
-    INTEGER(iwp) ::  icla       !< Left index limit for allocation of index-mapping and other auxiliary arrays
-    INTEGER(iwp) ::  iclw       !< Left index limit for children's parent-grid work arrays
-    INTEGER(iwp) ::  icr        !< Left index limit for children's parent-grid arrays
-    INTEGER(iwp) ::  icra       !< Right index limit for allocation of index-mapping and other auxiliary arrays
-    INTEGER(iwp) ::  icrw       !< Right index limit for children's parent-grid work arrays
-    INTEGER(iwp) ::  ig         !< running index for salsa gases
-    INTEGER(iwp) ::  jcn        !< North index limit for children's parent-grid arrays
-    INTEGER(iwp) ::  jcna       !< North index limit for allocation of index-mapping and other auxiliary arrays
-    INTEGER(iwp) ::  jcnw       !< North index limit for children's parent-grid work arrays
-    INTEGER(iwp) ::  jcs        !< South index limit for children's parent-grid arrays
-    INTEGER(iwp) ::  jcsa       !< South index limit for allocation of index-mapping and other auxiliary arrays
-    INTEGER(iwp) ::  jcsw       !< South index limit for children's parent-grid work arrays
-    INTEGER(iwp) ::  n          !< Running index for number of chemical species
-    INTEGER(iwp), DIMENSION(3) ::  val  !< Array for sending the child-grid dimensions to parent 
-    REAL(wp) ::  xcs        !<
-    REAL(wp) ::  xce        !<
-    REAL(wp) ::  ycs        !<
-    REAL(wp) ::  yce        !<
-
-    REAL(wp), DIMENSION(5) ::  fval     !< Array for sending the child-grid spacings etc to parent 
-                                             
+    INTEGER(iwp) ::  ierr                          !< MPI error code
+    INTEGER(iwp) ::  lb                            !< Running index for aerosol size bins
+    INTEGER(iwp) ::  lc                            !< Running index for aerosol mass bins
+    INTEGER(iwp) ::  lg                            !< Running index for salsa gases
+    INTEGER(iwp) ::  n                             !< Running index for number of chemical species
+    INTEGER(iwp), DIMENSION(3) ::  child_grid_dim  !< Array for sending the child-grid dimensions to parent 
+
+    REAL(wp), DIMENSION(5) ::  child_grid_info     !< Array for sending the child-grid spacings etc to parent 
+         
+    CHARACTER( LEN=da_namelen ) ::  myname         !< 
+    CHARACTER(LEN=5) ::  salsa_char                !<
+    
 !
 !-- Child setup
 !-- Root model does not have a parent and is not a child, therefore no child setup on root model
     IF ( .NOT. pmc_is_rootmodel() )  THEN
-
+!
+!--    ADD A DESCRIPTION HERE WHAT PMC_CHILDINIT DOES       
        CALL pmc_childinit
 !
@@ -1267,5 +1324,5 @@
 !--    in subroutines:
 !--    pmci_set_array_pointer (for parent arrays)
-!--    pmci_create_child_arrays (for child arrays)
+!--    pmci_create_childs_parent_grid_arrays (for child's parent-grid arrays)
        CALL pmc_set_dataarray_name( 'coarse', 'u'  ,'fine', 'u',  ierr )
        CALL pmc_set_dataarray_name( 'coarse', 'v'  ,'fine', 'v',  ierr )
@@ -1307,5 +1364,5 @@
        ENDIF
 
-       IF( particle_advection )  THEN
+       IF ( particle_advection )  THEN
           CALL pmc_set_dataarray_name( 'coarse', 'nr_part'  ,'fine',           &
                'nr_part',  ierr )
@@ -1315,9 +1372,9 @@
        
        IF ( air_chemistry  .AND.  nest_chemistry )  THEN
-          DO  n = 1, nspec
+          DO n = 1, nspec
              CALL pmc_set_dataarray_name( 'coarse',                            &
                                           'chem_' //                           &
                                           TRIM( chem_species(n)%name ),        &
-                                          'fine',                              &
+                                         'fine',                               &
                                           'chem_' //                           &
                                           TRIM( chem_species(n)%name ),        &
@@ -1327,6 +1384,6 @@
 
        IF ( salsa  .AND.  nest_salsa )  THEN
-          DO  ib = 1, nbins_aerosol
-             WRITE(salsa_char,'(i0)') ib
+          DO  lb = 1, nbins_aerosol
+             WRITE(salsa_char,'(i0)') lb
              CALL pmc_set_dataarray_name( 'coarse',                            &
                                           'an_' //                             &
@@ -1337,6 +1394,6 @@
                                           ierr )
           ENDDO
-          DO  ic = 1, nbins_aerosol * ncomponents_mass
-             WRITE(salsa_char,'(i0)') ic
+          DO  lc = 1, nbins_aerosol * ncomponents_mass
+             WRITE(salsa_char,'(i0)') lc
              CALL pmc_set_dataarray_name( 'coarse',                            &
                                           'am_' //                             &
@@ -1348,6 +1405,6 @@
           ENDDO
           IF ( .NOT. salsa_gases_from_chem )  THEN
-             DO  ig = 1, ngases_salsa
-                WRITE(salsa_char,'(i0)') ig
+             DO  lg = 1, ngases_salsa
+                WRITE(salsa_char,'(i0)') lg
                 CALL pmc_set_dataarray_name( 'coarse',                         &
                                              'sg_' //                          &
@@ -1364,17 +1421,17 @@
 !
 !--    Send grid to parent
-       val(1)  = nx
-       val(2)  = ny
-       val(3)  = nz
-       fval(1) = zw(nzt+1)
-       fval(2) = zw(nzt)
-       fval(3) = dx
-       fval(4) = dy
-       fval(5) = dz(1)
+       child_grid_dim(1)  = nx
+       child_grid_dim(2)  = ny
+       child_grid_dim(3)  = nz
+       child_grid_info(1) = zw(nzt+1)
+       child_grid_info(2) = zw(nzt)
+       child_grid_info(3) = dx
+       child_grid_info(4) = dy
+       child_grid_info(5) = dz(1)
 
        IF ( myid == 0 )  THEN
 
-          CALL pmc_send_to_parent( val, SIZE( val ), 0, 123, ierr )
-          CALL pmc_send_to_parent( fval, SIZE( fval ), 0, 124, ierr )
+          CALL pmc_send_to_parent( child_grid_dim, SIZE( child_grid_dim ), 0, 123, ierr )
+          CALL pmc_send_to_parent( child_grid_info, SIZE( child_grid_info ), 0, 124, ierr )
           CALL pmc_send_to_parent( coord_x, nx + 1 + 2 * nbgp, 0, 11, ierr )
           CALL pmc_send_to_parent( coord_y, ny + 1 + 2 * nbgp, 0, 12, ierr )
@@ -1393,37 +1450,40 @@
        CALL MPI_BCAST( parent_grid_info_int, 3, MPI_INTEGER, 0, comm2d, ierr )
 
-       cg%dx = parent_grid_info_real(3)
-       cg%dy = parent_grid_info_real(4)
-       cg%dz = parent_grid_info_real(7)
-       cg%nx = parent_grid_info_int(1)
-       cg%ny = parent_grid_info_int(2)
-       cg%nz = parent_grid_info_int(3)
+       pg%dx = parent_grid_info_real(3)
+       pg%dy = parent_grid_info_real(4)
+       pg%dz = parent_grid_info_real(7)
+       pg%nx = parent_grid_info_int(1)
+       pg%ny = parent_grid_info_int(2)
+       pg%nz = parent_grid_info_int(3)
 !
 !--    Get parent coordinates on coarse grid
-       ALLOCATE( cg%coord_x(-nbgp:cg%nx+nbgp) )
-       ALLOCATE( cg%coord_y(-nbgp:cg%ny+nbgp) )
-       ALLOCATE( cg%dzu(1:cg%nz+1) )
-       ALLOCATE( cg%dzw(1:cg%nz+1) )
-       ALLOCATE( cg%zu(0:cg%nz+1) )
-       ALLOCATE( cg%zw(0:cg%nz+1) )
+       ALLOCATE( pg%coord_x(-nbgp:pg%nx+nbgp) )
+       ALLOCATE( pg%coord_y(-nbgp:pg%ny+nbgp) )
+       ALLOCATE( pg%dzu(1:pg%nz+1) )
+       ALLOCATE( pg%dzw(1:pg%nz+1) )
+       ALLOCATE( pg%zu(0:pg%nz+1) )
+       ALLOCATE( pg%zw(0:pg%nz+1) )
 !
 !--    Get coarse grid coordinates and values of the z-direction from the parent
        IF ( myid == 0)  THEN
-          CALL pmc_recv_from_parent( cg%coord_x, cg%nx+1+2*nbgp, 0, 24, ierr )
-          CALL pmc_recv_from_parent( cg%coord_y, cg%ny+1+2*nbgp, 0, 25, ierr )
-          CALL pmc_recv_from_parent( cg%dzu, cg%nz+1, 0, 26, ierr )
-          CALL pmc_recv_from_parent( cg%dzw, cg%nz+1, 0, 27, ierr )
-          CALL pmc_recv_from_parent( cg%zu, cg%nz+2, 0, 28, ierr )
-          CALL pmc_recv_from_parent( cg%zw, cg%nz+2, 0, 29, ierr )
+          CALL pmc_recv_from_parent( pg%coord_x, pg%nx+1+2*nbgp, 0, 24, ierr )
+          CALL pmc_recv_from_parent( pg%coord_y, pg%ny+1+2*nbgp, 0, 25, ierr )
+          CALL pmc_recv_from_parent( pg%dzu, pg%nz+1, 0, 26, ierr )
+          CALL pmc_recv_from_parent( pg%dzw, pg%nz+1, 0, 27, ierr )
+          CALL pmc_recv_from_parent( pg%zu, pg%nz+2, 0, 28, ierr )
+          CALL pmc_recv_from_parent( pg%zw, pg%nz+2, 0, 29, ierr )
        ENDIF
 !
 !--    Broadcast this information
-       CALL MPI_BCAST( cg%coord_x, cg%nx+1+2*nbgp, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_BCAST( cg%coord_y, cg%ny+1+2*nbgp, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_BCAST( cg%dzu, cg%nz+1, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_BCAST( cg%dzw, cg%nz+1, MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_BCAST( cg%zu, cg%nz+2,  MPI_REAL, 0, comm2d, ierr )
-       CALL MPI_BCAST( cg%zw, cg%nz+2,  MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( pg%coord_x, pg%nx+1+2*nbgp, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( pg%coord_y, pg%ny+1+2*nbgp, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( pg%dzu, pg%nz+1, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( pg%dzw, pg%nz+1, MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( pg%zu, pg%nz+2,  MPI_REAL, 0, comm2d, ierr )
+       CALL MPI_BCAST( pg%zw, pg%nz+2,  MPI_REAL, 0, comm2d, ierr )
        CALL MPI_BCAST( rans_mode_parent, 1, MPI_LOGICAL, 0, comm2d, ierr )
+
+!  CHECK IF pmci_check_grid_matching COULD BE MOVED HERE.
+       
 !
 !--    Find the index bounds for the nest domain in the coarse-grid index space
@@ -1437,8 +1497,8 @@
        CALL  pmc_c_clear_next_array_list
 
-       ib = 1
-       ic = 1
-       ig = 1
        n  = 1
+       lb = 1
+       lc = 1
+       lg = 1
 
        DO  WHILE ( pmc_c_getnextarray( myname ) )
@@ -1451,22 +1511,17 @@
 !--       species and increment this subsequently.
           IF ( INDEX( TRIM( myname ), 'chem_' ) /= 0 )  THEN             
-             CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz, n )
+             CALL pmci_create_childs_parent_grid_arrays ( myname, ipl, ipr, jps, jpn, pg%nz, n )
              n = n + 1    
           ELSEIF ( INDEX( TRIM( myname ), 'an_' ) /= 0 )  THEN
-             CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz,&
-                                             ib )
-             ib = ib + 1
+             CALL pmci_create_childs_parent_grid_arrays ( myname, ipl, ipr, jps, jpn, pg%nz, lb )
+             lb = lb + 1
           ELSEIF ( INDEX( TRIM( myname ), 'am_' ) /= 0 )  THEN
-             CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz,&
-                                             ic )
-             ic = ic + 1
-          ELSEIF ( INDEX( TRIM( myname ), 'sg_' ) /= 0  .AND.                  &
-             .NOT. salsa_gases_from_chem )                                     &
-          THEN
-             CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz,&
-                                             ig )
-             ig = ig + 1
+             CALL pmci_create_childs_parent_grid_arrays ( myname, ipl, ipr, jps, jpn, pg%nz, lc )
+             lc = lc + 1
+          ELSEIF ( INDEX( TRIM( myname ), 'sg_' ) /= 0  .AND.  .NOT.  salsa_gases_from_chem )  THEN
+             CALL pmci_create_childs_parent_grid_arrays ( myname, ipl, ipr, jps, jpn, pg%nz, lg )
+             lg = lg + 1
           ELSE
-             CALL pmci_create_child_arrays ( myname, icl, icr, jcs, jcn, cg%nz )
+             CALL pmci_create_childs_parent_grid_arrays ( myname, ipl, ipr, jps, jpn, pg%nz )
           ENDIF
        ENDDO
@@ -1491,17 +1546,24 @@
 
        INTEGER(iwp), DIMENSION(5,numprocs) ::  coarse_bound_all     !< Transfer array for parent-grid index bounds
+
        INTEGER(iwp), DIMENSION(4)          ::  parent_bound_global  !< Transfer array for global parent-grid index bounds
        INTEGER(iwp), DIMENSION(2)          ::  size_of_array        !<
-       INTEGER(iwp) :: i        !< 
-       INTEGER(iwp) :: iauxl    !<
-       INTEGER(iwp) :: iauxr    !<
-       INTEGER(iwp) :: ijaux    !< 
-       INTEGER(iwp) :: j        !<
-       INTEGER(iwp) :: jauxs    !<
-       INTEGER(iwp) :: jauxn    !< 
+
+       INTEGER(iwp) ::  i       !< 
+       INTEGER(iwp) ::  iauxl   !<
+       INTEGER(iwp) ::  iauxr   !<
+       INTEGER(iwp) ::  ijaux   !< 
+       INTEGER(iwp) ::  j       !<
+       INTEGER(iwp) ::  jauxs   !<
+       INTEGER(iwp) ::  jauxn   !< 
+
        REAL(wp) ::  xexl        !< Parent-grid array exceedance behind the left edge of the child PE subdomain
        REAL(wp) ::  xexr        !< Parent-grid array exceedance behind the right edge of the child PE subdomain 
        REAL(wp) ::  yexs        !< Parent-grid array exceedance behind the south edge of the child PE subdomain
        REAL(wp) ::  yexn        !< Parent-grid array exceedance behind the north edge of the child PE subdomain
+       REAL(wp) ::  xcs         !< RENAME 
+       REAL(wp) ::  xce         !< RENAME 
+       REAL(wp) ::  ycs         !< RENAME 
+       REAL(wp) ::  yce         !< RENAME 
 
 !
@@ -1511,9 +1573,11 @@
 !--    Else the parent-grid cell is included in the neighbouring subdomain's 
 !--    anterpolation domain, or not included at all if we are at the outer 
-!--    edge of the child domain.
+!--    edge of the child domain. This may occur especially when a large grid-spacing
+!--    ratio is used.       
 !
 !--    Left
-       IF  ( bc_dirichlet_l )  THEN
-          xexl  = 2 * cg%dx
+!--    EXPLAIN THE EXTENSION HERE AND IN THE OTHER OCCASIONS (r, s, n)       
+       IF ( bc_dirichlet_l )  THEN
+          xexl  = 2 * pg%dx
           iauxl = 0
        ELSE
@@ -1522,7 +1586,7 @@
        ENDIF
        xcs     = coord_x(nxl) - xexl
-       DO  i = 0, cg%nx
-          IF ( cg%coord_x(i) + 0.5_wp * cg%dx >= xcs )  THEN
-             icl = MAX( 0, i )
+       DO  i = 0, pg%nx
+          IF ( pg%coord_x(i) + 0.5_wp * pg%dx >= xcs )  THEN   ! Consider changing >= to ==
+             ipl = MAX( 0, i )
              EXIT
           ENDIF
@@ -1530,6 +1594,6 @@
 !
 !--    Right
-       IF  ( bc_dirichlet_r )  THEN
-          xexr  = 2 * cg%dx
+       IF ( bc_dirichlet_r )  THEN
+          xexr  = 2 * pg%dx
           iauxr = 0  
        ELSE
@@ -1538,7 +1602,7 @@
        ENDIF
        xce  = coord_x(nxr+1) + xexr
-       DO  i = cg%nx, 0 , -1
-          IF ( cg%coord_x(i) + 0.5_wp * cg%dx <= xce )  THEN
-             icr = MIN( cg%nx, MAX( icl, i ) )
+       DO  i = pg%nx, 0 , -1
+          IF ( pg%coord_x(i) + 0.5_wp * pg%dx <= xce )  THEN
+             ipr = MIN( pg%nx, MAX( ipl, i ) )
              EXIT
           ENDIF
@@ -1546,6 +1610,6 @@
 !
 !--    South
-       IF  ( bc_dirichlet_s )  THEN
-          yexs  = 2 * cg%dy
+       IF ( bc_dirichlet_s )  THEN
+          yexs  = 2 * pg%dy
           jauxs = 0  
        ELSE
@@ -1554,7 +1618,7 @@
        ENDIF
        ycs  = coord_y(nys) - yexs
-       DO  j = 0, cg%ny
-          IF ( cg%coord_y(j) + 0.5_wp * cg%dy >= ycs )  THEN
-             jcs = MAX( 0, j )
+       DO  j = 0, pg%ny
+          IF ( pg%coord_y(j) + 0.5_wp * pg%dy >= ycs )  THEN
+             jps = MAX( 0, j )
              EXIT
           ENDIF
@@ -1563,5 +1627,5 @@
 !--    North
        IF  ( bc_dirichlet_n )  THEN
-          yexn  = 2 * cg%dy
+          yexn  = 2 * pg%dy
           jauxn = 0
        ELSE
@@ -1570,53 +1634,55 @@
        ENDIF
        yce  = coord_y(nyn+1) + yexn
-       DO  j = cg%ny, 0 , -1
-          IF ( cg%coord_y(j) + 0.5_wp * cg%dy <= yce )  THEN
-             jcn = MIN( cg%ny, MAX( jcs, j ) )
+       DO  j = pg%ny, 0 , -1
+          IF ( pg%coord_y(j) + 0.5_wp * pg%dy <= yce )  THEN
+             jpn = MIN( pg%ny, MAX( jps, j ) )
              EXIT
           ENDIF
        ENDDO
 !
-!--    Make sure that the indexing is contiguous (no gaps, no overlaps) 
-#if defined( __parallel )
+!--    Make sure that the indexing is contiguous (no gaps, no overlaps). 
+!--    This is a safety measure mainly for cases with high grid-spacing 
+!--    ratio and narrow child subdomains.
        IF ( nxl == 0 )  THEN
-          CALL MPI_SEND( icr, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
+          CALL MPI_SEND( ipr, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
        ELSE IF ( nxr == nx )  THEN
           CALL MPI_RECV( ijaux, 1, MPI_INTEGER, pleft, 717, comm2d, status, ierr )
-          icl = ijaux + 1
+          ipl = ijaux + 1
        ELSE
-          CALL MPI_SEND( icr, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
+          CALL MPI_SEND( ipr, 1, MPI_INTEGER, pright, 717, comm2d, ierr )
           CALL MPI_RECV( ijaux, 1, MPI_INTEGER, pleft, 717, comm2d, status, ierr ) 
-          icl = ijaux + 1
+          ipl = ijaux + 1
        ENDIF
        IF ( nys == 0 )  THEN
-          CALL MPI_SEND( jcn, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
+          CALL MPI_SEND( jpn, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
        ELSE IF ( nyn == ny )  THEN
           CALL MPI_RECV( ijaux, 1, MPI_INTEGER, psouth, 719, comm2d, status, ierr )
-          jcs = ijaux + 1
+          jps = ijaux + 1
        ELSE
-          CALL MPI_SEND( jcn, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
+          CALL MPI_SEND( jpn, 1, MPI_INTEGER, pnorth, 719, comm2d, ierr )
           CALL MPI_RECV( ijaux, 1, MPI_INTEGER, psouth, 719, comm2d, status, ierr ) 
-          jcs = ijaux + 1
-       ENDIF
-#endif       
-
-       WRITE(9,"('Pmci_map_fine_to_coarse_grid. Parent-grid array bounds: ',4(i4,2x))") icl, icr, jcs, jcn
+          jps = ijaux + 1
+       ENDIF
+
+       WRITE(9,"('Pmci_map_fine_to_coarse_grid. Parent-grid array bounds: ',4(i4,2x))")             &
+            ipl, ipr, jps, jpn
        FLUSH(9)
 
-       coarse_bound(1) = icl
-       coarse_bound(2) = icr
-       coarse_bound(3) = jcs
-       coarse_bound(4) = jcn
+       coarse_bound(1) = ipl
+       coarse_bound(2) = ipr
+       coarse_bound(3) = jps
+       coarse_bound(4) = jpn
        coarse_bound(5) = myid
 !
 !--    The following index bounds are used for allocating index mapping and some other auxiliary arrays
-       coarse_bound_aux(1) = icl - iauxl
-       coarse_bound_aux(2) = icr + iauxr
-       coarse_bound_aux(3) = jcs - jauxs
-       coarse_bound_aux(4) = jcn + jauxn
+       ipla = ipl - iauxl
+       ipra = ipr + iauxr
+       jpsa = jps - jauxs
+       jpna = jpn + jauxn
 !
 !--    Note that MPI_Gather receives data from all processes in the rank order
 !--    This fact is exploited in creating the index list in pmci_create_index_list
-       CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5,     &
+!    IMPROVE THIS COMMENT. EXPLAIN WHERE THIS INFORMATION IS NEEDED.
+       CALL MPI_GATHER( coarse_bound, 5, MPI_INTEGER, coarse_bound_all, 5,                          &
                         MPI_INTEGER, 0, comm2d, ierr )
 
@@ -1625,6 +1691,5 @@
           size_of_array(2) = SIZE( coarse_bound_all, 2 )
           CALL pmc_send_to_parent( size_of_array, 2, 0, 40, ierr )
-          CALL pmc_send_to_parent( coarse_bound_all, SIZE( coarse_bound_all ), &
-               0, 41, ierr )
+          CALL pmc_send_to_parent( coarse_bound_all, SIZE( coarse_bound_all ), 0, 41, ierr )
 !
 !--       Determine the global parent-grid index bounds       
@@ -1641,6 +1706,7 @@
        jpsg = parent_bound_global(3)
        jpng = parent_bound_global(4)
-       WRITE(9,"('Pmci_map_fine_to_coarse_grid. Global parent-grid index bounds iplg, iprg, jpsg, jpng: ',4(i4,2x))") iplg, iprg, jpsg, jpng
-       FLUSH(9)
+       WRITE( 9, "('Pmci_map_fine_to_coarse_grid. Global parent-grid index bounds iplg, iprg, jpsg, jpng: ',4(i4,2x))" ) &
+            iplg, iprg, jpsg, jpng
+       FLUSH( 9 )
        
     END SUBROUTINE pmci_map_fine_to_coarse_grid
@@ -1654,24 +1720,24 @@
        IMPLICIT NONE
 
-       INTEGER(iwp) ::  i         !< Child-grid index
-       INTEGER(iwp) ::  ii        !< Parent-grid index
+       INTEGER(iwp) ::  i         !< Child-grid index in the x-direction
+       INTEGER(iwp) ::  ii        !< Parent-grid index in the x-direction
        INTEGER(iwp) ::  istart    !<
        INTEGER(iwp) ::  ir        !<
-       INTEGER(iwp) ::  iw        !< Child-grid index limited to -1 <= iw <= nx+1
-       INTEGER(iwp) ::  j         !< Child-grid index
-       INTEGER(iwp) ::  jj        !< Parent-grid index
+       INTEGER(iwp) ::  iw        !< Child-grid index limited to -1 <= iw <= nx+1 for wall_flags_0
+       INTEGER(iwp) ::  j         !< Child-grid index in the y-direction
+       INTEGER(iwp) ::  jj        !< Parent-grid index in the y-direction
        INTEGER(iwp) ::  jstart    !<
        INTEGER(iwp) ::  jr        !<
-       INTEGER(iwp) ::  jw        !< Child-grid index limited to -1 <= jw <= ny+1
-       INTEGER(iwp) ::  k         !< Child-grid index
-       INTEGER(iwp) ::  kk        !< Parent-grid index
+       INTEGER(iwp) ::  jw        !< Child-grid index limited to -1 <= jw <= ny+1 for wall_flags_0
+       INTEGER(iwp) ::  k         !< Child-grid index in the z-direction
+       INTEGER(iwp) ::  kk        !< Parent-grid index in the z-direction
        INTEGER(iwp) ::  kstart    !<
-       INTEGER(iwp) ::  kw        !< Child-grid index limited to kw <= nzt+1
+       INTEGER(iwp) ::  kw        !< Child-grid index limited to kw <= nzt+1 for wall_flags_0
      
 !
 !--    Allocate child-grid work arrays for interpolation.
-       igsr = NINT( cg%dx / dx, iwp )
-       jgsr = NINT( cg%dy / dy, iwp )
-       kgsr = NINT( cg%dzw(1) / dzw(1), iwp )
+       igsr = NINT( pg%dx / dx, iwp )
+       jgsr = NINT( pg%dy / dy, iwp )
+       kgsr = NINT( pg%dzw(1) / dzw(1), iwp )
        WRITE(9,"('igsr, jgsr, kgsr: ',3(i3,2x))") igsr, jgsr, kgsr
        FLUSH(9)
@@ -1688,5 +1754,5 @@
 !--    coarse-grid levels below the child top-boundary level.
        kk = 0
-       DO  WHILE ( cg%zu(kk) <= zu(nzt) )
+       DO WHILE ( pg%zu(kk) <= zu(nzt) )
           kk = kk + 1
        ENDDO
